Index: trunk/SophyaLib/Manual/sophya.tex
===================================================================
--- trunk/SophyaLib/Manual/sophya.tex	(revision 978)
+++ trunk/SophyaLib/Manual/sophya.tex	(revision 988)
@@ -1,4 +1,5 @@
 \documentclass[twoside,11pt]{article}
 %  Package standard : Utilisation de caracteres accentues, mode francais et graphique
+\usepackage{url}
 \usepackage[latin1]{inputenc}
 \usepackage[T1]{fontenc}
@@ -11,4 +12,5 @@
 \usepackage{amssymb}
 
+%  Definition pour Docs Sophya
 \usepackage{defsophya}
 
@@ -18,13 +20,16 @@
 
 \begin{titlepage}
+%  The title page - top of the page with the title of the paper
 \titrehp{Sophya  \\ An overview }
+%  Authors list
 \auteurs{
-R. Ansari     &  ansari@lal.in2p3.fr       \\
-G. Le Meur    &  lemeur@lal.in2p3.fr       \\
-C. Magneville &  cmv@hep.saclay.cea.fr     \\
-S. Versille   &  versille@lal.in2p3.fr     
+R. Ansari            &  ansari@lal.in2p3.fr       \\
+G. Le Meur           &  lemeur@lal.in2p3.fr       \\
+C. Magneville        &  cmv@hep.saclay.cea.fr     \\
+S. Henrot-Versille   &  versille@in2p3.fr     
 }
 % \auteursall
-\titrebp{2}
+%  The title page - bottom of the page with the paper number
+\titrebp{1}
 \end{titlepage}
 
@@ -59,6 +64,5 @@
 ({\tt DataCard, DVList} \ldots). 
 \item[] {\bf TArray/} template numerical arrays, vectors and matrices
-({\tt PixelMap<T> SphericalMap<T>} \ldots) and few geometry 
-handling utility classes.
+({\tt PixelMap<T> SphericalMap<T>} \ldots) 
 \item[] {\bf NTools/} Some standard numerical analysis tools 
 (linear, and non linear parameter fitting, FFT, \ldots)
@@ -70,5 +74,7 @@
 CMB (Cosmic Microwave Background) data analysis problem:
 \begin{itemize}
-\item[] {\bf SkyMap/} Local and full sky maps 
+\item[] {\bf SkyMap/} Local and full sky maps, and few geometry 
+handling utility classes. \\
+({\tt PixelMap<T>, LocalMap<T>, SphericalMap<T>, \ldots})
 \item[] {\bf SkyT/} 
 classes for spectral emission and detector frequency response modelling \\
@@ -81,5 +87,5 @@
 external libraries:
 \begin{itemize}
-\item[] {\bf FitsIOSrever/} Classes for handling file input-output 
+\item[] {\bf FitsIOServer/} Classes for handling file input-output 
 in FITS format using the cfitsio library.
 \item[] {\bf LinAlg/} Interface with Lapack linear algebra package
@@ -96,8 +102,10 @@
 analysis program framework and the interfaces with the objects
 in SOPHYA.  The {\bf PI/} \footnote{the PI package documentation 
-is available from {\tt http://www.lal.in2p3.fr/recherche/eros/PeidaDoc/} } 
+is available from {\bf http://www.lal.in2p3.fr/recherche/eros/PeidaDoc/} } 
 and {\bf PIext/} modules are not currently part 
 of the SOPHYA CVS structure.
 \end{itemize}   
+
+\newpage 
 
 \section{Using Sophya}
@@ -140,11 +148,15 @@
 csh> make trivial
 \end{verbatim}
-This command should compile the {\tt trivial.cc} file, producing 
-{\tt \$HOME/`uname`-\$EROSCXX/Objs/trivial.o} and link it against the sophya
-libraries to produce {\tt \$HOME/`uname`-\$EROSCXX/Exec/trivial}.
+This command should compile the {\tt trivial.cc} file, 
+and link it against the sophya libraries. The object and executable 
+file names are: \\ 
+{\tt \$HOME/`uname`-\$EROSCXX/Objs/trivial.o} \\
+{\tt \$HOME/`uname`-\$EROSCXX/Exec/trivial}.
 \par 
 The file {\tt \$DPCBASEREP/Include/makefile\_example} provides another 
 example makefile.
 
+
+\newpage 
 
 \section{Building and installing Sophya}
@@ -183,5 +195,9 @@
 the external libraries directory tree has been set up in 
 {\tt /usr/local/ExtLibs/}. \\[3mm]
-\centerline{\bf \large the use of GNU make is mandatory.} 
+\centerline{ 
+	  \rule{20mm}{0.5mm} 
+	{\bf \large the use of GNU make is mandatory} 
+	\rule{20mm}{0.5mm} }
+
 \vspace*{3mm}
 \begin{verbatim}
@@ -237,32 +253,62 @@
 \end{verbatim}
 
-\section{Mgr/ module}
-This module contains scripts which can be used for ge
-blabla ...
-
-\section{SysTools module}
-This is a dclsa{AAAA} \\[2mm]
-\dclsa{AAA}
-This is a dclsb{BBBB}{BBBB} \\[2mm]
-\dclsbb{BBBB}{BBBB}
-This is a dclsc{CCCCC}{CCCCC}{CCCCC} \\[2mm]
-\dclsccc{\tcls{CCCCC}}{CCCCC}{CCCCC}
-
-
-\begin{figure}
-\dclsa{DataCard}
-\dclsbb{AnyDataObj}{NDataBlock$<$T$>$}
-\dclsccc{BaseArray}{TArray}{TMatrix}
-\dclsb{NDataBlock$<$T$>$}
-\dclscc{TArray}{TMatrix}
-\dclsc{\tcls{Tvector}}
-\caption{ Partial class diagram}
+\subsection{Mgr module}
+This module contains scripts which can be used for generating the 
+makefiles for each module.
+\begin{itemize}
+\item {\bf Makefile} Top level Makefile for builiding the libraries.
+\item {\bf Makefile.h} contains the defintion of compilation flags for the 
+different compilers and systems. This file is used for building the 
+library and generating {\bf MakefileUser.h} (to be included in makefiles).
+\item {\bf Makefile.slb} contains the rules for building shared libraries
+for the different compilers and systems. (to be included in makefiles)
+\item {\bf crerep\_sophya} c-shell script for creating the directory tree
+under {\tt \$DPCBASEREP} and {\tt \$DPCDEVREP}
+\item {\bf install\_sophya} c-shell script for installing the Sophya package.
+Usually from {\tt \$DPCDEVREP} to {\tt \$DPCBASEREP}
+\item {\bf mkmflien} c-shell script for making symbolic links or copying
+include files to {\tt \$DPCDEVREP/Include} or {\tt \$DPCBASEREP/Include}
+\item {\bf mkmf} c-shell script for generating module makefiles and the 
+top level makefile (named GNUmakefile)
+\item {\bf mkmflib} c-shell script for generating each library module 
+makefile (named GNUmakefile)
+\item {\bf mkmfprog} c-shell script for generating makefile for a module
+containing the source for executable programs (named GNUmakefile).
+\item {\bf mkmfPI} c-shell script for generating makefile for PI and PIext
+modules (named GNUmakefile)
+\item {\bf libdirs} List of Sophya modules without reference to external
+libraries.
+\item {\bf extlibdirs} List of Sophya modules with reference to external
+libraries.
+
+\end{itemize}
+ 
+\newpage
+
+\section{Learning Sophya through examples}
+The examples here illustrates the basic 
+usage of Sophya classes. Sophya documentation can be found at our web site: \\
+{\bf http://hfi-l2.in2p3.fr}. 
+
+\subsection{Using classes in SysTools}
+
+{\bf SysTools} contains utility classes such as {\tt DataCards} or 
+{\tt DVlist}, an hierarchy of exception classes for Sophya, a template
+class {\tcls{NDataBlock}} for handling reference counting on numerical
+arrays, as well as classes providing the services for implementing simple
+serialization. For simple programs, it is a good practice to handle 
+the exceptions at least at high level, in the {\tt main()} function. 
+The example below shows the exception handling and the usage 
+of Sophya persistence.
+\vspace*{5mm}
+
+\begin{figure}[hbt]
+\dclsa{PPersist}
+\dclsbb{PIOPersist}{PInPersist}
+\dclsb{POutPersist}
+\caption{partial class diagram for classes handling persistencein Sophya}
 \end{figure}
 
-
-PixelMap<T> --- LocalMap<T>
-                SphericalMap<T>  --- SphereThetaPhi<T>
-                                     SphereHEALPix<T>
-
+\input{ex1.inc}
 
 \end{document}