Index: trunk/SophyaExt/JThreadsC++/Examples/Makefile
===================================================================
--- trunk/SophyaExt/JThreadsC++/Examples/Makefile	(revision 1016)
+++ trunk/SophyaExt/JThreadsC++/Examples/Makefile	(revision 1018)
@@ -9,4 +9,5 @@
 
 SYSNOM = $(shell echo `uname`)
+SYSNOMD = $(shell echo `uname | sed 's/-//'`) 
 SYSCOMPNOM = $(SYSNOM)-$(CXX)
 
@@ -16,6 +17,7 @@
 
 SYSLIBS = -lpthread 
+CPPFLAGS   := -I$(INC)  -D$(SYSNOMD)
 ifeq ($(CXX),cxx)
-  CPPFLAGS   :=  -I$(INC) -pthread 
+  CPPFLAGS   :=  $(CPPFLAGS) -pthread 
 endif
 
Index: trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config.h
===================================================================
--- trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config.h	(revision 1016)
+++ trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config.h	(revision 1018)
@@ -11,156 +11,78 @@
  ***********************************************************************/
 
+/* -----------------------------------------------------------
+  Modified by R. Ansari (LAL-IN2P3/CNRS) for multi-platform
+     multi-compiler support      05/2000
+-------------------------------------------------------------- */
 
-/* Define if you need to in order for stat and other things to work.  */
-/* #undef _POSIX_SOURCE */
+#ifndef JTCCONFIG_H_SEEN
+#define JTCCONFIG_H_SEEN
 
-/* Define if your processor stores words with the most significant
-   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
-/* #undef WORDS_BIGENDIAN */
+/*  System dependence (thread capabilities) */
 
-/* Define if your c++ compiler doesn't know mutable. */
-/* #undef HAVE_NO_MUTABLE */
-
-/* Define if your c++ compiler doesn't have namespaces. */
-/* #undef HAVE_NO_NAMESPACE */
-
-/* Define if your c++ compiler supports iostream in namespace std. */
-/* #undef HAVE_STD_IOSTREAM */
-
-/* Define if your c++ compiler supports STL in namespace std. */
-#define HAVE_STD_STL 1
-
-/* Define if your c++ compiler can explicitly instanciate templates. */
-/* #undef HAVE_NO_EXPLICIT_TEMPLATES */
-
-/* Define if your c++ compiler does not have RTTI. */
-/* #undef HAVE_NO_RTTI */
-
-/* Define if your c++ compiler can't overload const type conversions. */
-/* #undef HAVE_NO_CONST_TYPE_CONVERSION_OVERLOAD */
-
-/* Define if your c++ compiler doesn't have typename. */
-/* #undef HAVE_NO_TYPENAME */
-
-/* Define if you don't have a prototype for gethostname(). */
-/* #undef HAVE_NO_GETHOSTNAME_PROTOTYPE */
-
-/* Define if there is no declaration for h_errno */
-/* #undef HAVE_NO_H_ERRNO_DECLARATION */
-
-/* Define if OS supports MIT threads. */
-/* #undef HAVE_MIT_THREADS */
-
-/* Define if OS supports FSU threads. */
-/* #undef HAVE_FSU_THREADS */
-
-/* Define if OS supports posix threads. */
+/* DEC/Compaq TruUnix64 (OSF1) */
+#if defined(OSF1)
 #define HAVE_POSIX_THREADS 1
-
-/* Define if OS supports DCE threads. */
-/* #undef HAVE_DCE_THREADS */
-
-/* Define if OS supports pthread_attr_setstacksize. */
 #define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
-
-/* Define if OS supports pthread_delay_np. */
 #define HAVE_PTHREAD_DELAY_NP 1
-
-/* Define if OS supports pthread_sched_yield. */
 #define HAVE_SCHED_YIELD 1
-
-/* Define if OS supports pthread_yield. */
-/* #undef HAVE_PTHREAD_YIELD */
-
-/* Define if JThreads/C++ has support for stop/suspend/resume. */
 #define HAVE_JTC_STOP 1
-
-/* The number of bytes in a bool.  */
-#define SIZEOF_BOOL 1
-
-/* The number of bytes in a char.  */
-#define SIZEOF_CHAR 1
-
-/* The number of bytes in a double.  */
-#define SIZEOF_DOUBLE 8
-
-/* The number of bytes in a float.  */
-#define SIZEOF_FLOAT 4
-
-/* The number of bytes in a int.  */
-#define SIZEOF_INT 4
-
-/* The number of bytes in a long.  */
-#define SIZEOF_LONG 8
-
-/* The number of bytes in a short.  */
-#define SIZEOF_SHORT 2
-
-/* Define if you have the strcasecmp function.  */
-#define HAVE_STRCASECMP 1
-
-/* Define if you have the strerror function.  */
-#define HAVE_STRERROR 1
-
-/* Define if you have the strncasecmp function.  */
-#define HAVE_STRNCASECMP 1
-
-/* Define if you have the <bstring.h> header file.  */
-/* #undef HAVE_BSTRING_H */
-
-/* Define if you have the <exception> header file.  */
-#define HAVE_EXCEPTION 1
-
-/* Define if you have the <exception.h> header file.  */
-#define HAVE_EXCEPTION_H 1
-
-/* Define if you have the <fstream> header file.  */
-/* #undef HAVE_FSTREAM */
-
-/* Define if you have the <iostream> header file.  */
-/* #undef HAVE_IOSTREAM */
-
-/* Define if you have the <sched.h> header file.  */
 #define HAVE_SCHED_H 1
 
-/* Define if you have the <stddef.h> header file.  */
-#define HAVE_STDDEF_H 1
+/* Linux  */
+#elif defined(Linux)
+#define HAVE_POSIX_THREADS 1
+#define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
+#define HAVE_SCHED_YIELD 1
+#define HAVE_JTC_STOP 1
+#define HAVE_SCHED_H 1
 
-/* Define if you have the <stdlib.h> header file.  */
-#define HAVE_STDLIB_H 1
+/* SGI - ** To be checked ** */
+#elif defined(IRIX64)
+#define HAVE_POSIX_THREADS 1
+#define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
+#define HAVE_SCHED_YIELD 1
+#define HAVE_JTC_STOP 1
+#define HAVE_SCHED_H 1
+#if !defined(__sgi)
+#define __sgi 1
+#endif
 
-/* Define if you have the <strings.h> header file.  */
-#define HAVE_STRINGS_H 1
+/* IBM-AIX - ** To be checked ** */
+#elif defined(AIX)
+#define HAVE_POSIX_THREADS 1
+#define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
+#define HAVE_SCHED_YIELD 1
+#define HAVE_JTC_STOP 1
+#define HAVE_SCHED_H 1
 
-/* Define if you have the <strstream> header file.  */
-/* #undef HAVE_STRSTREAM */
+/* Sun-Solaris - ** To be checked ** */
+#elif defined(SunOS)
+#define HAVE_POSIX_THREADS 1
+#define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
+#define HAVE_SCHED_YIELD 1
+#define HAVE_JTC_STOP 1
+#define HAVE_SCHED_H 1
 
-/* Define if you have the <sys/sched.h> header file.  */
-/* #undef HAVE_SYS_SCHED_H */
+#else
+#error  Undefined OS type in JTC/Config.h 
+#endif
 
-/* Define if you have the <sys/select.h> header file.  */
-#define HAVE_SYS_SELECT_H 1
+/* Compiler dependend flags   */
+/* ---- g++ KCC cxx (DEC) CC (SGI) --- */
+/* All supported compilers have bool type, and exception handling */
+#define SIZEOF_BOOL 1
+#define HAVE_EXCEPTION 1
+#define HAVE_EXCEPTION_H 1  /* To be checked */
 
-/* Define if you have the <sys/time.h> header file.  */
-#define HAVE_SYS_TIME_H 1
+#endif
 
-/* Define if you have the <sys/types.h> header file.  */
-#define HAVE_SYS_TYPES_H 1
 
-/* Define if you have the <terminate.h> header file.  */
-/* #undef HAVE_TERMINATE_H */
 
-/* Define if you have the <termio.h> header file.  */
-#define HAVE_TERMIO_H 1
 
-/* Define if you have the <termios.h> header file.  */
-#define HAVE_TERMIOS_H 1
 
-/* Define if you have the <unexpected.h> header file.  */
-/* #undef HAVE_UNEXPECTED_H */
 
-/* Define if you have the <unistd.h> header file.  */
-#define HAVE_UNISTD_H 1
 
-/* Define if you have the malloc library (-lmalloc).  */
-/* #undef HAVE_LIBMALLOC */
+
+
+
Index: trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config_OSF1-cxx.h
===================================================================
--- trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config_OSF1-cxx.h	(revision 1018)
+++ trunk/SophyaExt/JThreadsC++/JTCSrc/JTC/Config_OSF1-cxx.h	(revision 1018)
@@ -0,0 +1,166 @@
+/* include/JTC/Config.h.  Generated automatically by configure.  */
+/* include/JTC/Config.h.in.  Generated automatically from configure.in by autoheader.  */
+/***********************************************************************
+ *
+ * Copyright (c) 2000
+ * Object Oriented Concepts, Inc.
+ * Billerica, MA, USA
+ *
+ * All Rights Reserved
+ *
+ ***********************************************************************/
+
+
+/* Define if you need to in order for stat and other things to work.  */
+/* #undef _POSIX_SOURCE */
+
+/* Define if your processor stores words with the most significant
+   byte first (like Motorola and SPARC, unlike Intel and VAX).  */
+/* #undef WORDS_BIGENDIAN */
+
+/* Define if your c++ compiler doesn't know mutable. */
+/* #undef HAVE_NO_MUTABLE */
+
+/* Define if your c++ compiler doesn't have namespaces. */
+/* #undef HAVE_NO_NAMESPACE */
+
+/* Define if your c++ compiler supports iostream in namespace std. */
+/* #undef HAVE_STD_IOSTREAM */
+
+/* Define if your c++ compiler supports STL in namespace std. */
+#define HAVE_STD_STL 1
+
+/* Define if your c++ compiler can explicitly instanciate templates. */
+/* #undef HAVE_NO_EXPLICIT_TEMPLATES */
+
+/* Define if your c++ compiler does not have RTTI. */
+/* #undef HAVE_NO_RTTI */
+
+/* Define if your c++ compiler can't overload const type conversions. */
+/* #undef HAVE_NO_CONST_TYPE_CONVERSION_OVERLOAD */
+
+/* Define if your c++ compiler doesn't have typename. */
+/* #undef HAVE_NO_TYPENAME */
+
+/* Define if you don't have a prototype for gethostname(). */
+/* #undef HAVE_NO_GETHOSTNAME_PROTOTYPE */
+
+/* Define if there is no declaration for h_errno */
+/* #undef HAVE_NO_H_ERRNO_DECLARATION */
+
+/* Define if OS supports MIT threads. */
+/* #undef HAVE_MIT_THREADS */
+
+/* Define if OS supports FSU threads. */
+/* #undef HAVE_FSU_THREADS */
+
+/* Define if OS supports posix threads. */
+#define HAVE_POSIX_THREADS 1
+
+/* Define if OS supports DCE threads. */
+/* #undef HAVE_DCE_THREADS */
+
+/* Define if OS supports pthread_attr_setstacksize. */
+#define HAVE_PTHREAD_ATTR_SETSTACKSIZE 1
+
+/* Define if OS supports pthread_delay_np. */
+#define HAVE_PTHREAD_DELAY_NP 1
+
+/* Define if OS supports pthread_sched_yield. */
+#define HAVE_SCHED_YIELD 1
+
+/* Define if OS supports pthread_yield. */
+/* #undef HAVE_PTHREAD_YIELD */
+
+/* Define if JThreads/C++ has support for stop/suspend/resume. */
+#define HAVE_JTC_STOP 1
+
+/* The number of bytes in a bool.  */
+#define SIZEOF_BOOL 1
+
+/* The number of bytes in a char.  */
+#define SIZEOF_CHAR 1
+
+/* The number of bytes in a double.  */
+#define SIZEOF_DOUBLE 8
+
+/* The number of bytes in a float.  */
+#define SIZEOF_FLOAT 4
+
+/* The number of bytes in a int.  */
+#define SIZEOF_INT 4
+
+/* The number of bytes in a long.  */
+#define SIZEOF_LONG 8
+
+/* The number of bytes in a short.  */
+#define SIZEOF_SHORT 2
+
+/* Define if you have the strcasecmp function.  */
+#define HAVE_STRCASECMP 1
+
+/* Define if you have the strerror function.  */
+#define HAVE_STRERROR 1
+
+/* Define if you have the strncasecmp function.  */
+#define HAVE_STRNCASECMP 1
+
+/* Define if you have the <bstring.h> header file.  */
+/* #undef HAVE_BSTRING_H */
+
+/* Define if you have the <exception> header file.  */
+#define HAVE_EXCEPTION 1
+
+/* Define if you have the <exception.h> header file.  */
+#define HAVE_EXCEPTION_H 1
+
+/* Define if you have the <fstream> header file.  */
+/* #undef HAVE_FSTREAM */
+
+/* Define if you have the <iostream> header file.  */
+/* #undef HAVE_IOSTREAM */
+
+/* Define if you have the <sched.h> header file.  */
+#define HAVE_SCHED_H 1
+
+/* Define if you have the <stddef.h> header file.  */
+#define HAVE_STDDEF_H 1
+
+/* Define if you have the <stdlib.h> header file.  */
+#define HAVE_STDLIB_H 1
+
+/* Define if you have the <strings.h> header file.  */
+#define HAVE_STRINGS_H 1
+
+/* Define if you have the <strstream> header file.  */
+/* #undef HAVE_STRSTREAM */
+
+/* Define if you have the <sys/sched.h> header file.  */
+/* #undef HAVE_SYS_SCHED_H */
+
+/* Define if you have the <sys/select.h> header file.  */
+#define HAVE_SYS_SELECT_H 1
+
+/* Define if you have the <sys/time.h> header file.  */
+#define HAVE_SYS_TIME_H 1
+
+/* Define if you have the <sys/types.h> header file.  */
+#define HAVE_SYS_TYPES_H 1
+
+/* Define if you have the <terminate.h> header file.  */
+/* #undef HAVE_TERMINATE_H */
+
+/* Define if you have the <termio.h> header file.  */
+#define HAVE_TERMIO_H 1
+
+/* Define if you have the <termios.h> header file.  */
+#define HAVE_TERMIOS_H 1
+
+/* Define if you have the <unexpected.h> header file.  */
+/* #undef HAVE_UNEXPECTED_H */
+
+/* Define if you have the <unistd.h> header file.  */
+#define HAVE_UNISTD_H 1
+
+/* Define if you have the malloc library (-lmalloc).  */
+/* #undef HAVE_LIBMALLOC */
Index: trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile
===================================================================
--- trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile	(revision 1016)
+++ trunk/SophyaExt/JThreadsC++/JTCSrc/Makefile	(revision 1018)
@@ -9,4 +9,5 @@
 
 SYSNOM = $(shell echo `uname`)
+SYSNOMD = $(shell echo `uname | sed 's/-//'`) 
 SYSCOMPNOM = $(SYSNOM)-$(CXX)
 
@@ -17,7 +18,8 @@
 	$(COMPILE.cc) -o $@ $<
 
+CPPFLAGS   :=  -I. -D$(SYSNOMD)
 #  Flag pour compilo DEC-cxx (Compaq)
 ifeq ($(CXX),cxx)
-  CPPFLAGS   :=  -I. -pthread -nopt -distinguish_nested_enums 
+  CPPFLAGS   :=  $(CPPFLAGS) -pthread -nopt -distinguish_nested_enums 
 endif
 